import pickle
from baryon_oo import save_matrix_from_dict

def get_operators_134_2_T1g(basis, choice):
    ops = []
    if basis == 'DR_Euclidean':
        if choice == 0:
            ops = {
                # from output of baryon code
                # {'0100': 1.0, '0111': -1.0, '2322': 1.0, '2333': -1.0},
                # {'0100': 1.0, '0111': 1.0, '2322': 1.0, '2333': 1.0},
                # {'0101': 1.0, '2323': 1.0}
                # after diagonalization
                1: {'0111': 0.70710678, '2333': 0.70710678},
                -1: {'0100': 0.70710678, '2322': 0.70710678},
                0: {'0101': 0.70710678, '2323': 0.70710678}
            }
        if choice == 1:
            ops = [
                # before diagonalization
                # # # row 0 choice 1
                # {'0102': 0.3333333333333333, '0201': -0.3333333333333333, '0300': 0.3333333333333333,
                #  '0311': -0.3333333333333333, '0322': 0.3333333333333333, '0333': -0.3333333333333333,
                #  '1211': 0.3333333333333333, '1222': -0.3333333333333333, '1233': 0.3333333333333333},
                # # row 0 choice 2
                # {'0113': 0.3333333333333333, '0201': -0.3333333333333333, '0223': 0.3333333333333333,
                #  '0300': 0.3333333333333333, '0311': -0.3333333333333333, '0333': -0.3333333333333333,
                #  '1211': 0.3333333333333333, '1222': -0.3333333333333333, '1323': 0.3333333333333333},
                # # row 1 choice 1
                # {'0102': 0.3333333333333333, '0201': -0.3333333333333333, '0300': 0.3333333333333333,
                #  '0311': 0.3333333333333333, '0322': 0.3333333333333333, '0333': 0.3333333333333333,
                #  '1211': -0.3333333333333333, '1222': -0.3333333333333333, '1233': -0.3333333333333333},
                # # # row 1 choice 2
                # {'0113': 0.3333333333333333, '0201': 0.3333333333333333, '0223': -0.3333333333333333,
                #  '0300': -0.3333333333333333, '0311': -0.3333333333333333, '0333': -0.3333333333333333,
                #  '1211': 0.3333333333333333, '1222': 0.3333333333333333, '1323': 0.3333333333333333},
                # # row 2 choice 1
                # {'0103': 0.4472135954999579, '0211': 0.4472135954999579, '0233': -0.4472135954999579,
                #  '0301': -0.4472135954999579, '1322': 0.4472135954999579},
                # # # row 2 choice 2
                # {'0112': 0.4472135954999579, '0211': -0.4472135954999579, '0301': 0.4472135954999579,
                #  '0323': 0.4472135954999579, '1223': -0.4472135954999579},
                # should actually be diagonal!!!
                # 0  +i
                {'0113': 0.2778500408491952, '0311': -0.5132243341956932, '0333': -0.5132243341956932,
                 '1211': 0.5132243341956932, '1233': 0.23537429334649804, '1323': 0.2778500408491952},
                # 0  1
                {'0103': -0.2672612443271508, '0112': 0.2672612443271508, '0211': -0.534522480202759,
                 '0233': 0.2672612443271508, '0301': 0.534522480202759, '0323': 0.2672612443271508, '1223': -0.2672612443271508,
                 '1322': -0.2672612443271508},
                # 0  -i
                {'0102': 0.2778500412843016, '0201': -0.5132243341171737, '0223': 0.23537429283287228,
                 '0300': 0.5132243341171737, '0322': 0.2778500412843016, '1222': -0.5132243341171737},
                #
                # 1  +i
                {'0113': -0.5351968970147197, '0311': -0.09658185891125382, '0333': -0.09658185891125382,
                 '1211': 0.09658185891125382, '1233': 0.6317787559259737, '1323': -0.5351968970147197},
                # 1  1
                {'0103': 0.408248290463863, '0112': 0.408248290463863, '0233': -0.408248290463863, '0323': 0.408248290463863,
                 '1223': -0.408248290463863, '1322': 0.408248290463863},
                # 1  -i
                {'0102': -0.535196892023269, '0201': -0.09658186813109745, '0223': 0.6317787601543664,
                 '0300': 0.09658186813109745, '0322': -0.535196892023269, '1222': -0.09658186813109745},
                # breaking into choices
            ]

        if choice == 2:
            ops = [
                # # row 0 choice 3
                # {'0122': 0.4472135954999579, '0212': -0.4472135954999579, '0302': 0.4472135954999579,
                #  '0313': -0.4472135954999579, '1213': 0.4472135954999579},
                # # row 0 choice 4
                # {'0133': 0.4472135954999579, '0203': 0.4472135954999579, '0212': -0.4472135954999579,
                #  '0313': -0.4472135954999579, '1312': 0.4472135954999579},
                # # row 1 choice 3
                # {'0122': 0.4472135954999579, '0212': -0.4472135954999579, '0302': 0.4472135954999579,
                #  '0313': 0.4472135954999579, '1213': -0.4472135954999579},
                # # row 1 choice 4
                # {'0133': 0.4472135954999579, '0203': -0.4472135954999579, '0212': 0.4472135954999579,
                #  '0313': -0.4472135954999579, '1312': 0.4472135954999579},
                # # row 2 choice 3
                # {'0123': 0.5773502691896258, '0213': -0.5773502691896258, '0312': 0.5773502691896258},
                # # row 2 choice 4
                # {'0303': 0.7071067811865475, '1212': -0.7071067811865475}
                # after diagonalization
                {'0133': 0.447213595499958, '0313': -0.723606797749979, '1213': 0.27639320225002106, '1312': 0.447213595499958},
                {'0122': 0.447213595499958, '0203': 0.27639320225002095, '0212': -0.7236067977499789, '0302': 0.447213595499958},
                {'0133': 0.4472135954999579, '0313': 0.2763932022500211, '1213': -0.723606797749979, '1312': 0.4472135954999579},
                {'0122': -0.44721359549995776, '0203': 0.7236067977499792, '0212': -0.27639320225002134,
                 '0302': -0.44721359549995776},
                {'0123': 0.5773502691896258, '0213': -0.5773502691896258, '0312': 0.5773502691896258},
                {'0303': 0.7071067811865476, '1212': -0.7071067811865476}
            ]

    return ops

def main():
    Nc = 4
    isospin_rep = '134_2'
    rep = 'T1g'
    basis = 'DR_Euclidean'
    Sz_list = [1, -1, 0]  # note the order is specific to above, can be checked with diagonalize.py
    ops_dict = {}
    for choice in [0]:
        ops_dict[choice] = {}
        for Sz in Sz_list:
            ops_dict[choice][Sz] = get_operators_134_2_T1g(basis, choice)[Sz]
            filename = f'Operators/{basis}/gamma_matrix_Nc{Nc}_isospin{isospin_rep}_{rep}_Sz{Sz}_choice{choice}.txt'
            save_matrix_from_dict(ops_dict[choice][Sz], filename)
    with open(f'Operators/{basis}/diagonalized_1234_T2g.pkl', 'wb') as f:
        pickle.dump(ops_dict, f)


if __name__ == '__main__':
    main()